// =========  Start of RH_Gauge.cpp generated code ==========
//  RH_Gauge.cpp from RH_Gauge by pfodGUIdesigner V1.0.4181
/*
  (c)2022 Forward Computing and Control Pty. Ltd.
  NSW Australia, www.forward.com.au
  This code is not warranted to be fit for any purpose. You may only use it at your own risk.
  This code may be freely used for both private and commercial use
  Provided this copyright is maintained.
*/

#ifndef RH_GAUGE_H
#include "RH_Gauge.h"
#endif

RH_Gauge::RH_Gauge(pfodParser* parserPtr, pfodDwgs* dwgsPtr) : pfodDrawing(parserPtr, dwgsPtr) {
  forceReload = true; // force reload on reboot, e.g. reprogrammed
  rh = 0;
}

void RH_Gauge::setRH(int _rh) {
  rh = _rh;
}

bool RH_Gauge::processDwgCmds() { // return true if handled else false
  byte dwgCmd = parserPtr->parseDwgCmd(); // dwgCmd is '\0' if this is NOT a dwg cmd
  if (!dwgCmd) {
    return false; // not dwg cmd not handled
  }
  return false; // not handled
}


void RH_Gauge::drawDwg0() {
  dwgsPtr->arc().color(7).offset(0.00,0.00).radius(11.00).start(210.00).angle(-240.00).filled().send();
  dwgsPtr->arc().color(0).offset(0.00,0.00).radius(12.00).start(210.00).angle(0.00).send();
  dwgsPtr->arc().color(0).offset(0.00,0.00).radius(12.00).start(162.00).angle(0.00).send();
  dwgsPtr->arc().color(0).offset(0.00,0.00).radius(12.00).start(114.00).angle(0.00).send();
  dwgsPtr->arc().color(0).offset(0.00,0.00).radius(12.00).start(66.00).angle(0.00).send();
  dwgsPtr->arc().color(0).offset(0.00,0.00).radius(12.00).start(18.00).angle(0.00).send();
  dwgsPtr->arc().color(0).offset(0.00,0.00).radius(12.00).start(-30.00).angle(0.00).send();
  dwgsPtr->label().color(0).offset(-13.00,6.00).fontSize(0).center().value(0.000000).decimals(0).units("%").send();
  dwgsPtr->label().color(0).offset(-14.50,-4.00).fontSize(0).center().value(20.000000).decimals(0).units("%").send();
  dwgsPtr->label().color(0).offset(-5.50,-12.00).fontSize(0).center().value(40.000000).decimals(0).units("%").send();
  dwgsPtr->label().color(0).offset(6.00,-12.00).fontSize(0).center().value(60.000000).decimals(0).units("%").send();
  dwgsPtr->label().color(0).offset(14.50,-4.00).fontSize(0).center().value(80.000000).decimals(0).units("%").send();
  dwgsPtr->label().color(0).offset(14.00,6.00).fontSize(0).center().value(100.000000).decimals(0).units("%").send();
  dwgsPtr->index().idx(_update_idx_17).send();
  dwgsPtr->index().idx(_update_idx_18).send();
  dwgsPtr->arc().idx(_idx_15).color(15).offset(0.00,0.00).radius(6.00).start(210.00).angle(-240.00).filled().send();
  dwgsPtr->label().idx(_idx_16).color(0).offset(0.00,5.00).text("RH").fontSize(2).bold().center().send();
  dwgsPtr->index().idx(_update_idx_16).send();
}

void RH_Gauge::updateDwg() {
  int rhArc = map(rh,0,100,0,-240); // map rh to -ve angle
  dwgsPtr->arc().idx(_update_idx_17).color(9).offset(0.00,0.00).radius(11.00).start(210.00).angle(rhArc).filled().send();
  dwgsPtr->arc().idx(_update_idx_18).color(0).offset(0.00,0.00).radius(12.00).start(210+rhArc).angle(0.00).send();
  dwgsPtr->label().idx(_update_idx_16).color(0).offset(0.00,0.00).fontSize(6).bold().center().value(rh).decimals(0).units("%").send();
}

bool RH_Gauge::sendDwg() {
  if (!parserPtr->cmdEquals(*this)) {
    return false; // not this dwg's loadCmd
  }  // else
  // ======== begin debugging
  Serial.print(" sendDwg() cmd "); Serial.print((char*)parserPtr->getCmd());
  if (parserPtr->isRefresh()) {
    Serial.print(" isRefresh");
  }
  byte* argPtr = parserPtr->getFirstArg();
  if (*argPtr) {
    Serial.print("  args: ");
    while (*argPtr) {
      Serial.print("  "); Serial.print((char*)argPtr);
      argPtr = parserPtr->getNextArg(argPtr);
    }
  }
  Serial.print("\n");
  //======= end debugging =======
  if (parserPtr->isRefresh() && !forceReload) { // refresh and not forceReload just send update
    sendUpdate();
  } else {
    forceReload = false; //
    long pfodLongRtn = 0;
    uint8_t* pfodFirstArg = parserPtr->getFirstArg(); // may point to \0 if no arguments in this msg.
    parserPtr->parseLong(pfodFirstArg, &pfodLongRtn); // parse first arg as a long
    sendFullDrawing(pfodLongRtn);
  }
  return true;
}

void RH_Gauge::sendFullDrawing(long dwgIdx) {
  if (dwgIdx == 0) {
    dwgsPtr->start(50, 50, dwgsPtr->WHITE, true);  // the dwg size 50x50 and color (WHITE) are ignored when this drawing is inserted in the main dwg
    //true means more to come
    parserPtr->sendRefreshAndVersion(0); //need to set a version number for image refresh to work!!
    drawDwg0(); //
    dwgsPtr->end();
    
    // if drawing msg is >1023 split it in to two or more parts and add extra else if (dwgIdx == .. ) blocks here
    
  } else if (dwgIdx == 1) {
    dwgsPtr->startUpdate(false);  // always send update last so this is the last msg => false
    updateDwg(); // update with current state, // defined in display.cpp
    dwgsPtr->end();
    
  } else {
    parserPtr->print(F("{}")); // always return somthing
  }
}

void RH_Gauge::sendUpdate() {
  dwgsPtr->startUpdate();  // dwg refresh updates must be <1024 bytes, i.e. can only be 1 msg
  updateDwg();
  dwgsPtr->end();
}

void RH_Gauge::printDwgCmdReceived(Print *outPtr) {
  if (!outPtr) {
    return;
  }
  outPtr->print("     touchZone cmd "); outPtr->print((const char*)parserPtr->getDwgCmd()); outPtr->print(" at ");
  outPtr->print("("); outPtr->print(parserPtr->getTouchedX()); outPtr->print(",");
  outPtr->print(parserPtr->getTouchedY()); outPtr->print(") ");
  if (parserPtr->isTouch()) {
    outPtr->print("touch type:TOUCHED");
  }
  outPtr->println();
  if (*parserPtr->getEditedText()) { // first char not '\0'
    outPtr->print("     Edited text '"); outPtr->print((const char*)parserPtr->getEditedText()); outPtr->println("'");
  }
}
// =========  End of RH_Gauge.cpp generated code ==========
